import Gio from 'gi://Gio';

import {Extension} from 'resource:///org/gnome/shell/extensions/extension.js';

export function getSettings() {
    const extensionObject = Extension.lookupByUUID('openai-gnome@etixsoftware.de');
    return extensionObject.getSettings('org.gnome.shell.extensions.etixsoftware.openai');
}

export function isGnomeDarkModeEnabled() {
    const settings = new Gio.Settings({ schema_id: 'org.gnome.desktop.interface' });
    const gtkThemeName = settings.get_string('gtk-theme');

    return gtkThemeName.includes('-Dark-Solid');
}
